/**
 * Copyright 2005-2012 The Kuali Foundation
 *
 * Licensed under the Educational Community License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.opensource.org/licenses/ecl2.php
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.kuali.rice.kew.impl.peopleflow;

import org.apache.commons.lang.StringUtils;
import org.kuali.rice.krad.web.controller.MaintenanceDocumentController;
import org.kuali.rice.krad.web.form.MaintenanceForm;
import org.kuali.rice.krad.web.form.UifFormBase;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Controller for the people flow maintenance document
 *
 * @author Kuali Rice Team (rice.collab@kuali.org)
 */
@Controller
@RequestMapping(value = "/peopleFlowMaintenance")
public class PeopleFlowController extends MaintenanceDocumentController {

    /**
     * Invoked for the refresh of the type attributes group to prepare the type attribute bos for the peopleflow
     */
    @RequestMapping(params = "methodToCall=" + "prepareTypeAttributes")
    public ModelAndView prepareTypeAttributes(@ModelAttribute("KualiForm") UifFormBase form, BindingResult result,
            HttpServletRequest request, HttpServletResponse response) throws Exception {
        MaintenanceForm maintenanceForm = (MaintenanceForm) form;

        PeopleFlowBo peopleFlow =
                (PeopleFlowBo) maintenanceForm.getDocument().getNewMaintainableObject().getDataObject();
        if (StringUtils.isNotBlank(peopleFlow.getTypeId())) {
            peopleFlow.rebuildTypeAttributes();
        }

        return getUIFModelAndView(form);
    }

}
